diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/hwmp-protocol-mac.cc ns-3.40/src/mesh/model/dot11s/hwmp-protocol-mac.cc
--- ns-3.39/src/mesh/model/dot11s/hwmp-protocol-mac.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/hwmp-protocol-mac.cc	2023-09-27 13:30:37.834839600 -0700
@@ -120,7 +120,7 @@
     // this is the last header to remove.
     packet->RemoveHeader(elements, packet->GetSize());
     std::vector<HwmpProtocol::FailedDestination> failedDestinations;
-    for (MeshInformationElementVector::Iterator i = elements.Begin(); i != elements.End(); i++)
+    for (auto i = elements.Begin(); i != elements.End(); i++)
     {
         if ((*i)->ElementId() == IE_RANN)
         {
@@ -169,10 +169,7 @@
             m_stats.rxPerr++;
             std::vector<HwmpProtocol::FailedDestination> destinations =
                 perr->GetAddressUnitVector();
-            for (std::vector<HwmpProtocol::FailedDestination>::const_iterator i =
-                     destinations.begin();
-                 i != destinations.end();
-                 i++)
+            for (auto i = destinations.begin(); i != destinations.end(); i++)
             {
                 failedDestinations.push_back(*i);
             }
@@ -263,7 +260,7 @@
     NS_LOG_FUNCTION(this);
     Ptr<Packet> packet = Create<Packet>();
     MeshInformationElementVector elements;
-    for (std::vector<IePreq>::iterator i = preq.begin(); i != preq.end(); i++)
+    for (auto i = preq.begin(); i != preq.end(); i++)
     {
         elements.AddInformationElement(Ptr<IePreq>(&(*i)));
     }
@@ -278,7 +275,7 @@
     hdr.SetAddr3(m_protocol->GetAddress());
     // Send Management frame
     std::vector<Mac48Address> receivers = m_protocol->GetPreqReceivers(m_ifIndex);
-    for (std::vector<Mac48Address>::const_iterator i = receivers.begin(); i != receivers.end(); i++)
+    for (auto i = receivers.begin(); i != receivers.end(); i++)
     {
         hdr.SetAddr1(*i);
         m_stats.txPreq++;
@@ -292,7 +289,7 @@
 HwmpProtocolMac::RequestDestination(Mac48Address dst, uint32_t originator_seqno, uint32_t dst_seqno)
 {
     NS_LOG_FUNCTION(this << dst << originator_seqno << dst_seqno);
-    for (std::vector<IePreq>::iterator i = m_myPreq.begin(); i != m_myPreq.end(); i++)
+    for (auto i = m_myPreq.begin(); i != m_myPreq.end(); i++)
     {
         if (i->IsFull())
         {
@@ -372,10 +369,7 @@
     Ptr<Packet> packet = Create<Packet>();
     Ptr<IePerr> perr = Create<IePerr>();
     MeshInformationElementVector elements;
-    for (std::vector<HwmpProtocol::FailedDestination>::const_iterator i =
-             failedDestinations.begin();
-         i != failedDestinations.end();
-         i++)
+    for (auto i = failedDestinations.begin(); i != failedDestinations.end(); i++)
     {
         if (!perr->IsFull())
         {
@@ -406,7 +400,7 @@
         receivers.push_back(Mac48Address::GetBroadcast());
     }
     // Send Management frame
-    for (std::vector<Mac48Address>::const_iterator i = receivers.begin(); i != receivers.end(); i++)
+    for (auto i = receivers.begin(); i != receivers.end(); i++)
     {
         //
         // 64-bit Intel valgrind complains about hdr.SetAddr1 (*i).  It likes this
@@ -429,13 +423,10 @@
     // All duplicates in PERR are checked here, and there is no reason to
     // check it at any other place
     {
-        std::vector<Mac48Address>::const_iterator end = receivers.end();
-        for (std::vector<Mac48Address>::const_iterator i = receivers.begin(); i != end; i++)
+        for (auto i = receivers.begin(); i != receivers.end(); i++)
         {
             bool should_add = true;
-            for (std::vector<Mac48Address>::const_iterator j = m_myPerr.receivers.begin();
-                 j != m_myPerr.receivers.end();
-                 j++)
+            for (auto j = m_myPerr.receivers.begin(); j != m_myPerr.receivers.end(); j++)
             {
                 if ((*i) == (*j))
                 {
@@ -450,17 +441,10 @@
         }
     }
     {
-        std::vector<HwmpProtocol::FailedDestination>::const_iterator end = failedDestinations.end();
-        for (std::vector<HwmpProtocol::FailedDestination>::const_iterator i =
-                 failedDestinations.begin();
-             i != end;
-             i++)
+        for (auto i = failedDestinations.begin(); i != failedDestinations.end(); i++)
         {
             bool should_add = true;
-            for (std::vector<HwmpProtocol::FailedDestination>::const_iterator j =
-                     m_myPerr.destinations.begin();
-                 j != m_myPerr.destinations.end();
-                 j++)
+            for (auto j = m_myPerr.destinations.begin(); j != m_myPerr.destinations.end(); j++)
             {
                 if (((*i).destination == (*j).destination) && ((*j).seqnum > (*i).seqnum))
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/hwmp-protocol-mac.h ns-3.40/src/mesh/model/dot11s/hwmp-protocol-mac.h
--- ns-3.39/src/mesh/model/dot11s/hwmp-protocol-mac.h	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/hwmp-protocol-mac.h	2023-09-27 13:30:37.834839600 -0700
@@ -20,7 +20,8 @@
 #ifndef HWMP_STATE_H
 #define HWMP_STATE_H
 
-#include "ns3/hwmp-protocol.h"
+#include "hwmp-protocol.h"
+
 #include "ns3/mesh-wifi-interface-mac-plugin.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/hwmp-rtable.cc ns-3.40/src/mesh/model/dot11s/hwmp-rtable.cc
--- ns-3.39/src/mesh/model/dot11s/hwmp-rtable.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/hwmp-rtable.cc	2023-09-27 13:30:37.834839600 -0700
@@ -70,7 +70,7 @@
 {
     NS_LOG_FUNCTION(this << destination << retransmitter << interface << metric
                          << lifetime.GetSeconds() << seqnum);
-    std::map<Mac48Address, ReactiveRoute>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i == m_routes.end())
     {
         ReactiveRoute newroute;
@@ -113,7 +113,7 @@
     precursor.interface = precursorInterface;
     precursor.address = precursorAddress;
     precursor.whenExpire = Simulator::Now() + lifetime;
-    std::map<Mac48Address, ReactiveRoute>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i != m_routes.end())
     {
         bool should_add = true;
@@ -161,7 +161,7 @@
 HwmpRtable::DeleteReactivePath(Mac48Address destination)
 {
     NS_LOG_FUNCTION(this << destination);
-    std::map<Mac48Address, ReactiveRoute>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i != m_routes.end())
     {
         m_routes.erase(i);
@@ -172,7 +172,7 @@
 HwmpRtable::LookupReactive(Mac48Address destination)
 {
     NS_LOG_FUNCTION(this << destination);
-    std::map<Mac48Address, ReactiveRoute>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i == m_routes.end())
     {
         return LookupResult();
@@ -189,7 +189,7 @@
 HwmpRtable::LookupReactiveExpired(Mac48Address destination)
 {
     NS_LOG_FUNCTION(this << destination);
-    std::map<Mac48Address, ReactiveRoute>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i == m_routes.end())
     {
         return LookupResult();
@@ -232,8 +232,7 @@
     NS_LOG_FUNCTION(this << peerAddress);
     HwmpProtocol::FailedDestination dst;
     std::vector<HwmpProtocol::FailedDestination> retval;
-    for (std::map<Mac48Address, ReactiveRoute>::iterator i = m_routes.begin(); i != m_routes.end();
-         i++)
+    for (auto i = m_routes.begin(); i != m_routes.end(); i++)
     {
         if (i->second.retransmitter == peerAddress)
         {
@@ -259,12 +258,10 @@
     NS_LOG_FUNCTION(this << destination);
     // We suppose that no duplicates here can be
     PrecursorList retval;
-    std::map<Mac48Address, ReactiveRoute>::iterator route = m_routes.find(destination);
+    auto route = m_routes.find(destination);
     if (route != m_routes.end())
     {
-        for (std::vector<Precursor>::const_iterator i = route->second.precursors.begin();
-             i != route->second.precursors.end();
-             i++)
+        for (auto i = route->second.precursors.begin(); i != route->second.precursors.end(); i++)
         {
             if (i->whenExpire > Simulator::Now())
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/hwmp-rtable.h ns-3.40/src/mesh/model/dot11s/hwmp-rtable.h
--- ns-3.39/src/mesh/model/dot11s/hwmp-rtable.h	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/hwmp-rtable.h	2023-09-27 13:30:37.834839600 -0700
@@ -20,7 +20,8 @@
 #ifndef HWMP_RTABLE_H
 #define HWMP_RTABLE_H
 
-#include "ns3/hwmp-protocol.h"
+#include "hwmp-protocol.h"
+
 #include "ns3/mac48-address.h"
 #include "ns3/nstime.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/ie-dot11s-beacon-timing.cc ns-3.40/src/mesh/model/dot11s/ie-dot11s-beacon-timing.cc
--- ns-3.39/src/mesh/model/dot11s/ie-dot11s-beacon-timing.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/ie-dot11s-beacon-timing.cc	2023-09-27 13:30:37.834839600 -0700
@@ -99,9 +99,7 @@
         return;
     }
     // First we lookup if this element already exists
-    for (NeighboursTimingUnitsList::const_iterator i = m_neighbours.begin();
-         i != m_neighbours.end();
-         i++)
+    for (auto i = m_neighbours.begin(); i != m_neighbours.end(); i++)
     {
         if (((*i)->GetAid() == AidToU8(aid)) &&
             ((*i)->GetLastBeacon() == TimestampToU16(last_beacon)) &&
@@ -121,7 +119,7 @@
 void
 IeBeaconTiming::DelNeighboursTimingElementUnit(uint16_t aid, Time last_beacon, Time beacon_interval)
 {
-    for (NeighboursTimingUnitsList::iterator i = m_neighbours.begin(); i != m_neighbours.end(); i++)
+    for (auto i = m_neighbours.begin(); i != m_neighbours.end(); i++)
     {
         if (((*i)->GetAid() == AidToU8(aid)) &&
             ((*i)->GetLastBeacon() == TimestampToU16(last_beacon)) &&
@@ -137,7 +135,7 @@
 void
 IeBeaconTiming::ClearTimingElement()
 {
-    for (NeighboursTimingUnitsList::iterator j = m_neighbours.begin(); j != m_neighbours.end(); j++)
+    for (auto j = m_neighbours.begin(); j != m_neighbours.end(); j++)
     {
         (*j) = nullptr;
     }
@@ -154,9 +152,7 @@
 IeBeaconTiming::Print(std::ostream& os) const
 {
     os << "BeaconTiming=(Number of units=" << (uint16_t)m_numOfUnits;
-    for (NeighboursTimingUnitsList::const_iterator j = m_neighbours.begin();
-         j != m_neighbours.end();
-         j++)
+    for (auto j = m_neighbours.begin(); j != m_neighbours.end(); j++)
     {
         os << "(AID=" << (uint16_t)(*j)->GetAid() << ", Last beacon at=" << (*j)->GetLastBeacon()
            << ", with beacon interval=" << (*j)->GetBeaconInterval() << ")";
@@ -167,9 +163,7 @@
 void
 IeBeaconTiming::SerializeInformationField(Buffer::Iterator i) const
 {
-    for (NeighboursTimingUnitsList::const_iterator j = m_neighbours.begin();
-         j != m_neighbours.end();
-         j++)
+    for (auto j = m_neighbours.begin(); j != m_neighbours.end(); j++)
     {
         i.WriteU8((*j)->GetAid());
         i.WriteHtolsbU16((*j)->GetLastBeacon());
@@ -223,7 +217,7 @@
 {
     try
     {
-        const IeBeaconTiming& aa = dynamic_cast<const IeBeaconTiming&>(a);
+        const auto& aa = dynamic_cast<const IeBeaconTiming&>(a);
 
         if (m_numOfUnits != aa.m_numOfUnits)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/ie-dot11s-perr.cc ns-3.40/src/mesh/model/dot11s/ie-dot11s-perr.cc
--- ns-3.39/src/mesh/model/dot11s/ie-dot11s-perr.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/ie-dot11s-perr.cc	2023-09-27 13:30:37.834839600 -0700
@@ -140,9 +140,7 @@
 void
 IePerr::DeleteAddressUnit(Mac48Address address)
 {
-    for (std::vector<HwmpProtocol::FailedDestination>::iterator i = m_addressUnits.begin();
-         i != m_addressUnits.end();
-         i++)
+    for (auto i = m_addressUnits.begin(); i != m_addressUnits.end(); i++)
     {
         if (i->destination == address)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/ie-dot11s-perr.h ns-3.40/src/mesh/model/dot11s/ie-dot11s-perr.h
--- ns-3.39/src/mesh/model/dot11s/ie-dot11s-perr.h	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/ie-dot11s-perr.h	2023-09-27 13:30:37.834839600 -0700
@@ -20,7 +20,8 @@
 #ifndef PERR_INFORMATION_ELEMENT_H
 #define PERR_INFORMATION_ELEMENT_H
 
-#include "ns3/hwmp-protocol.h"
+#include "hwmp-protocol.h"
+
 #include "ns3/mac48-address.h"
 #include "ns3/mesh-information-element-vector.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/ie-dot11s-preq.cc ns-3.40/src/mesh/model/dot11s/ie-dot11s-preq.cc
--- ns-3.39/src/mesh/model/dot11s/ie-dot11s-preq.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/ie-dot11s-preq.cc	2023-09-27 13:30:37.834839600 -0700
@@ -266,9 +266,7 @@
     i.WriteHtolsbU32(m_metric);
     i.WriteU8(m_destCount);
     int written = 0;
-    for (std::vector<Ptr<DestinationAddressUnit>>::const_iterator j = m_destinations.begin();
-         j != m_destinations.end();
-         j++)
+    for (auto j = m_destinations.begin(); j != m_destinations.end(); j++)
     {
         uint8_t flags = 0;
         if ((*j)->IsDo())
@@ -386,9 +384,7 @@
                                      Mac48Address dest_address,
                                      uint32_t dest_seq_number)
 {
-    for (std::vector<Ptr<DestinationAddressUnit>>::const_iterator i = m_destinations.begin();
-         i != m_destinations.end();
-         i++)
+    for (auto i = m_destinations.begin(); i != m_destinations.end(); i++)
     {
         if ((*i)->GetDestinationAddress() == dest_address)
         {
@@ -407,9 +403,7 @@
 void
 IePreq::DelDestinationAddressElement(Mac48Address dest_address)
 {
-    for (std::vector<Ptr<DestinationAddressUnit>>::iterator i = m_destinations.begin();
-         i != m_destinations.end();
-         i++)
+    for (auto i = m_destinations.begin(); i != m_destinations.end(); i++)
     {
         if ((*i)->GetDestinationAddress() == dest_address)
         {
@@ -423,9 +417,7 @@
 void
 IePreq::ClearDestinationAddressElements()
 {
-    for (std::vector<Ptr<DestinationAddressUnit>>::iterator j = m_destinations.begin();
-         j != m_destinations.end();
-         j++)
+    for (auto j = m_destinations.begin(); j != m_destinations.end(); j++)
     {
         (*j) = nullptr;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/peer-link.cc ns-3.40/src/mesh/model/dot11s/peer-link.cc
--- ns-3.39/src/mesh/model/dot11s/peer-link.cc	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/peer-link.cc	2023-09-27 13:30:37.834839600 -0700
@@ -19,7 +19,7 @@
  *          Pavel Boyko <boyko@iitp.ru>
  */
 
-#include "ns3/peer-link.h"
+#include "peer-link.h"
 
 #include "peer-management-protocol-mac.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/peer-link.h ns-3.40/src/mesh/model/dot11s/peer-link.h
--- ns-3.39/src/mesh/model/dot11s/peer-link.h	2023-07-05 14:23:48.033428200 -0700
+++ ns-3.40/src/mesh/model/dot11s/peer-link.h	2023-09-27 13:30:37.834839600 -0700
@@ -21,11 +21,12 @@
 #ifndef PEER_LINK_H
 #define PEER_LINK_H
 
+#include "ie-dot11s-beacon-timing.h"
+#include "ie-dot11s-configuration.h"
+#include "ie-dot11s-peer-management.h"
+
 #include "ns3/callback.h"
 #include "ns3/event-id.h"
-#include "ns3/ie-dot11s-beacon-timing.h"
-#include "ns3/ie-dot11s-configuration.h"
-#include "ns3/ie-dot11s-peer-management.h"
 #include "ns3/mac48-address.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/dot11s/peer-management-protocol.cc ns-3.40/src/mesh/model/dot11s/peer-management-protocol.cc
--- ns-3.39/src/mesh/model/dot11s/peer-management-protocol.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/dot11s/peer-management-protocol.cc	2023-09-27 13:30:37.834839600 -0700
@@ -18,7 +18,7 @@
  *          Aleksey Kovalenko <kovalenko@iitp.ru>
  */
 
-#include "ns3/peer-management-protocol.h"
+#include "peer-management-protocol.h"
 
 #include "ie-dot11s-configuration.h"
 #include "ie-dot11s-id.h"
@@ -105,9 +105,9 @@
 {
     // cancel cleanup event and go through the map of peer links,
     // deleting each
-    for (PeerLinksMap::iterator j = m_peerLinks.begin(); j != m_peerLinks.end(); j++)
+    for (auto j = m_peerLinks.begin(); j != m_peerLinks.end(); j++)
     {
-        for (PeerLinksOnInterface::iterator i = j->second.begin(); i != j->second.end(); i++)
+        for (auto i = j->second.begin(); i != j->second.end(); i++)
         {
             (*i) = nullptr;
         }
@@ -121,7 +121,7 @@
 PeerManagementProtocol::Install(Ptr<MeshPointDevice> mp)
 {
     std::vector<Ptr<NetDevice>> interfaces = mp->GetInterfaces();
-    for (std::vector<Ptr<NetDevice>>::iterator i = interfaces.begin(); i != interfaces.end(); i++)
+    for (auto i = interfaces.begin(); i != interfaces.end(); i++)
     {
         Ptr<WifiNetDevice> wifiNetDev = (*i)->GetObject<WifiNetDevice>();
         if (!wifiNetDev)
@@ -154,9 +154,9 @@
         return nullptr;
     }
     Ptr<IeBeaconTiming> retval = Create<IeBeaconTiming>();
-    PeerLinksMap::iterator iface = m_peerLinks.find(interface);
+    auto iface = m_peerLinks.find(interface);
     NS_ASSERT(iface != m_peerLinks.end());
-    for (PeerLinksOnInterface::iterator i = iface->second.begin(); i != iface->second.end(); i++)
+    for (auto i = iface->second.begin(); i != iface->second.end(); i++)
     {
         // If we do not know peer Assoc Id, we shall not add any info
         // to a beacon timing element
@@ -180,8 +180,7 @@
 {
     // PM STATE Machine
     // Check that a given beacon is not from our interface
-    for (PeerManagementProtocolMacMap::const_iterator i = m_plugins.begin(); i != m_plugins.end();
-         i++)
+    for (auto i = m_plugins.begin(); i != m_plugins.end(); i++)
     {
         if (i->second->GetAddress() == peerAddress)
         {
@@ -304,9 +303,9 @@
         NS_FATAL_ERROR("Peer link must not exist.");
     }
     // Plugin must exist
-    PeerManagementProtocolMacMap::iterator plugin = m_plugins.find(interface);
+    auto plugin = m_plugins.find(interface);
     NS_ASSERT(plugin != m_plugins.end());
-    PeerLinksMap::iterator iface = m_peerLinks.find(interface);
+    auto iface = m_peerLinks.find(interface);
     NS_ASSERT(iface != m_peerLinks.end());
     new_link->SetLocalAid(m_lastAssocId++);
     new_link->SetInterface(interface);
@@ -323,9 +322,9 @@
 Ptr<PeerLink>
 PeerManagementProtocol::FindPeerLink(uint32_t interface, Mac48Address peerAddress)
 {
-    PeerLinksMap::iterator iface = m_peerLinks.find(interface);
+    auto iface = m_peerLinks.find(interface);
     NS_ASSERT(iface != m_peerLinks.end());
-    for (PeerLinksOnInterface::iterator i = iface->second.begin(); i != iface->second.end(); i++)
+    for (auto i = iface->second.begin(); i != iface->second.end(); i++)
     {
         if ((*i)->GetPeerAddress() == peerAddress)
         {
@@ -355,10 +354,9 @@
 PeerManagementProtocol::GetPeers(uint32_t interface) const
 {
     std::vector<Mac48Address> retval;
-    PeerLinksMap::const_iterator iface = m_peerLinks.find(interface);
+    auto iface = m_peerLinks.find(interface);
     NS_ASSERT(iface != m_peerLinks.end());
-    for (PeerLinksOnInterface::const_iterator i = iface->second.begin(); i != iface->second.end();
-         i++)
+    for (auto i = iface->second.begin(); i != iface->second.end(); i++)
     {
         if ((*i)->LinkIsEstab())
         {
@@ -373,12 +371,9 @@
 {
     std::vector<Ptr<PeerLink>> links;
 
-    for (PeerLinksMap::const_iterator iface = m_peerLinks.begin(); iface != m_peerLinks.end();
-         ++iface)
+    for (auto iface = m_peerLinks.begin(); iface != m_peerLinks.end(); ++iface)
     {
-        for (PeerLinksOnInterface::const_iterator i = iface->second.begin();
-             i != iface->second.end();
-             i++)
+        for (auto i = iface->second.begin(); i != iface->second.end(); i++)
         {
             if ((*i)->LinkIsEstab())
             {
@@ -426,19 +421,18 @@
     {
         return;
     }
-    PeerLinksMap::iterator iface = m_peerLinks.find(interface);
+    auto iface = m_peerLinks.find(interface);
     NS_ASSERT(iface != m_peerLinks.end());
     NS_ASSERT(m_plugins.find(interface) != m_plugins.end());
 
-    std::map<uint32_t, Time>::const_iterator lastBeacon = m_lastBeacon.find(interface);
-    std::map<uint32_t, Time>::const_iterator beaconInterval = m_beaconInterval.find(interface);
+    auto lastBeacon = m_lastBeacon.find(interface);
+    auto beaconInterval = m_beaconInterval.find(interface);
     if ((lastBeacon == m_lastBeacon.end()) || (beaconInterval == m_beaconInterval.end()))
     {
         return;
     }
     // my last beacon in 256 us units
-    uint16_t lastBeaconInTimeElement =
-        (uint16_t)((lastBeacon->second.GetMicroSeconds() >> 8) & 0xffff);
+    auto lastBeaconInTimeElement = (uint16_t)((lastBeacon->second.GetMicroSeconds() >> 8) & 0xffff);
 
     NS_ASSERT_MSG(TuToTime(m_maxBeaconShift) <= m_beaconInterval[interface],
                   "Wrong beacon shift parameters");
@@ -451,14 +445,12 @@
     }
     // check whether all my peers receive my beacon and I'am not in collision with other beacons
 
-    for (PeerLinksOnInterface::iterator i = iface->second.begin(); i != iface->second.end(); i++)
+    for (auto i = iface->second.begin(); i != iface->second.end(); i++)
     {
         bool myBeaconExists = false;
         IeBeaconTiming::NeighboursTimingUnitsList neighbors =
             (*i)->GetBeaconTimingElement().GetNeighboursTimingElementsList();
-        for (IeBeaconTiming::NeighboursTimingUnitsList::const_iterator j = neighbors.begin();
-             j != neighbors.end();
-             j++)
+        for (auto j = neighbors.begin(); j != neighbors.end(); j++)
         {
             if ((*i)->GetPeerAid() == (*j)->GetAid())
             {
@@ -494,7 +486,7 @@
         shift = (int)m_beaconShift->GetValue();
     } while (shift == 0);
     // Apply beacon shift parameters:
-    PeerManagementProtocolMacMap::iterator plugin = m_plugins.find(interface);
+    auto plugin = m_plugins.find(interface);
     NS_ASSERT(plugin != m_plugins.end());
     plugin->second->SetBeaconShift(TuToTime(shift));
 }
@@ -550,7 +542,7 @@
                                        PeerLink::PeerState ostate,
                                        PeerLink::PeerState nstate)
 {
-    PeerManagementProtocolMacMap::iterator plugin = m_plugins.find(interface);
+    auto plugin = m_plugins.find(interface);
     NS_ASSERT(plugin != m_plugins.end());
     NS_LOG_DEBUG("Link between me:" << m_address << " my interface:" << plugin->second->GetAddress()
                                     << " and peer mesh point:" << peerMeshPointAddress
@@ -635,18 +627,14 @@
 {
     os << "<PeerManagementProtocol>" << std::endl;
     m_stats.Print(os);
-    for (PeerManagementProtocolMacMap::const_iterator plugins = m_plugins.begin();
-         plugins != m_plugins.end();
-         plugins++)
+    for (auto plugins = m_plugins.begin(); plugins != m_plugins.end(); plugins++)
     {
         // Take statistics from plugin:
         plugins->second->Report(os);
         // Print all active peer links:
-        PeerLinksMap::const_iterator iface = m_peerLinks.find(plugins->second->m_ifIndex);
+        auto iface = m_peerLinks.find(plugins->second->m_ifIndex);
         NS_ASSERT(iface != m_peerLinks.end());
-        for (PeerLinksOnInterface::const_iterator i = iface->second.begin();
-             i != iface->second.end();
-             i++)
+        for (auto i = iface->second.begin(); i != iface->second.end(); i++)
         {
             (*i)->Report(os);
         }
@@ -658,9 +646,7 @@
 PeerManagementProtocol::ResetStats()
 {
     m_stats = Statistics(m_stats.linksTotal); // don't reset number of links
-    for (PeerManagementProtocolMacMap::const_iterator plugins = m_plugins.begin();
-         plugins != m_plugins.end();
-         plugins++)
+    for (auto plugins = m_plugins.begin(); plugins != m_plugins.end(); plugins++)
     {
         plugins->second->ResetStats();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/flame/flame-protocol.cc ns-3.40/src/mesh/model/flame/flame-protocol.cc
--- ns-3.39/src/mesh/model/flame/flame-protocol.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/flame/flame-protocol.cc	2023-09-27 13:30:37.834839600 -0700
@@ -324,8 +324,7 @@
 {
     m_mp = mp;
     std::vector<Ptr<NetDevice>> interfaces = mp->GetInterfaces();
-    for (std::vector<Ptr<NetDevice>>::const_iterator i = interfaces.begin(); i != interfaces.end();
-         i++)
+    for (auto i = interfaces.begin(); i != interfaces.end(); i++)
     {
         // Checking for compatible net device
         Ptr<WifiNetDevice> wifiNetDev = (*i)->GetObject<WifiNetDevice>();
@@ -423,8 +422,7 @@
        << "broadcastInterval=\"" << m_broadcastInterval.GetSeconds() << "\"" << std::endl
        << "maxCost=\"" << (uint16_t)m_maxCost << "\">" << std::endl;
     m_stats.Print(os);
-    for (FlamePluginMap::const_iterator plugin = m_interfaces.begin(); plugin != m_interfaces.end();
-         plugin++)
+    for (auto plugin = m_interfaces.begin(); plugin != m_interfaces.end(); plugin++)
     {
         plugin->second->Report(os);
     }
@@ -435,8 +433,7 @@
 FlameProtocol::ResetStats()
 {
     m_stats = Statistics();
-    for (FlamePluginMap::const_iterator plugin = m_interfaces.begin(); plugin != m_interfaces.end();
-         plugin++)
+    for (auto plugin = m_interfaces.begin(); plugin != m_interfaces.end(); plugin++)
     {
         plugin->second->ResetStats();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/flame/flame-rtable.cc ns-3.40/src/mesh/model/flame/flame-rtable.cc
--- ns-3.39/src/mesh/model/flame/flame-rtable.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/flame/flame-rtable.cc	2023-09-27 13:30:37.834839600 -0700
@@ -70,7 +70,7 @@
                      const uint8_t cost,
                      const uint16_t seqnum)
 {
-    std::map<Mac48Address, Route>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i == m_routes.end())
     {
         Route newroute;
@@ -93,7 +93,7 @@
 FlameRtable::LookupResult
 FlameRtable::Lookup(Mac48Address destination)
 {
-    std::map<Mac48Address, Route>::iterator i = m_routes.find(destination);
+    auto i = m_routes.find(destination);
     if (i == m_routes.end())
     {
         return LookupResult();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-information-element-vector.cc ns-3.40/src/mesh/model/mesh-information-element-vector.cc
--- ns-3.39/src/mesh/model/mesh-information-element-vector.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-information-element-vector.cc	2023-09-27 13:30:37.834839600 -0700
@@ -47,7 +47,7 @@
 
 MeshInformationElementVector::~MeshInformationElementVector()
 {
-    for (IE_VECTOR::iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    for (auto i = m_elements.begin(); i != m_elements.end(); i++)
     {
         *i = nullptr;
     }
@@ -79,7 +79,7 @@
 void
 MeshInformationElementVector::Serialize(Buffer::Iterator start) const
 {
-    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    for (auto i = m_elements.begin(); i != m_elements.end(); i++)
     {
         start = (*i)->Serialize(start);
     }
@@ -164,7 +164,7 @@
 void
 MeshInformationElementVector::Print(std::ostream& os) const
 {
-    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    for (auto i = m_elements.begin(); i != m_elements.end(); i++)
     {
         os << "(";
         (*i)->Print(os);
@@ -198,7 +198,7 @@
 Ptr<WifiInformationElement>
 MeshInformationElementVector::FindFirst(WifiInformationElementId id) const
 {
-    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    for (auto i = m_elements.begin(); i != m_elements.end(); i++)
     {
         if ((*i)->ElementId() == id)
         {
@@ -212,7 +212,7 @@
 MeshInformationElementVector::GetSize() const
 {
     uint32_t size = 0;
-    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    for (auto i = m_elements.begin(); i != m_elements.end(); i++)
     {
         size += (*i)->GetSerializedSize();
     }
@@ -234,10 +234,8 @@
     // I'm leaving it like this, however, so that there is the option of
     // having individual Information Elements implement slightly more
     // flexible equality operators.
-    MeshInformationElementVector::IE_VECTOR::const_iterator j = a.m_elements.begin();
-    for (MeshInformationElementVector::IE_VECTOR::const_iterator i = m_elements.begin();
-         i != m_elements.end();
-         i++, j++)
+    auto j = a.m_elements.begin();
+    for (auto i = m_elements.begin(); i != m_elements.end(); i++, j++)
     {
         if (!(*(*i) == *(*j)))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-l2-routing-protocol.cc ns-3.40/src/mesh/model/mesh-l2-routing-protocol.cc
--- ns-3.39/src/mesh/model/mesh-l2-routing-protocol.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-l2-routing-protocol.cc	2023-09-27 13:30:37.834839600 -0700
@@ -18,10 +18,11 @@
  *          Pavel Boyko <boyko@iitp.ru>
  */
 
-#include "ns3/mesh-l2-routing-protocol.h"
+#include "mesh-l2-routing-protocol.h"
+
+#include "mesh-point-device.h"
 
 #include "ns3/log.h"
-#include "ns3/mesh-point-device.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mesh/model/mesh-point-device.cc ns-3.40/src/mesh/model/mesh-point-device.cc
--- ns-3.39/src/mesh/model/mesh-point-device.cc	2023-07-05 14:23:48.037428100 -0700
+++ ns-3.40/src/mesh/model/mesh-point-device.cc	2023-09-27 13:30:37.834839600 -0700
@@ -18,10 +18,11 @@
  *         Pavel Boyko <boyko@iitp.ru>
  */
 
-#include "ns3/mesh-point-device.h"
+#include "mesh-point-device.h"
+
+#include "mesh-wifi-interface-mac.h"
 
 #include "ns3/log.h"
-#include "ns3/mesh-wifi-interface-mac.h"
 #include "ns3/packet.h"
 #include "ns3/pointer.h"
 #include "ns3/simulator.h"
@@ -82,8 +83,7 @@
 MeshPointDevice::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Ptr<NetDevice>>::iterator iter = m_ifaces.begin(); iter != m_ifaces.end();
-         iter++)
+    for (auto iter = m_ifaces.begin(); iter != m_ifaces.end(); iter++)
     {
         *iter = nullptr;
     }
@@ -398,7 +398,7 @@
 MeshPointDevice::GetInterface(uint32_t n) const
 {
     NS_LOG_FUNCTION(this << n);
-    for (std::vector<Ptr<NetDevice>>::const_iterator i = m_ifaces.begin(); i != m_ifaces.end(); i++)
+    for (auto i = m_ifaces.begin(); i != m_ifaces.end(); i++)
     {
         if ((*i)->GetIfIndex() == n)
         {
@@ -515,7 +515,7 @@
     }
     else
     {
-        for (std::vector<Ptr<NetDevice>>::iterator i = m_ifaces.begin(); i != m_ifaces.end(); i++)
+        for (auto i = m_ifaces.begin(); i != m_ifaces.end(); i++)
         {
             (*i)->SendFrom(packet->Copy(), src, dst, protocol);
         }
